/*
 * generated by Xtext 2.11.0
 */
package com.mncml.implementation.pogo.dsl.serializer;

import com.google.inject.Inject;
import com.mncml.implementation.pogo.dsl.services.PogoDslGrammarAccess;
import java.util.Set;
import org.eclipse.emf.ecore.EObject;
import org.eclipse.emf.ecore.EPackage;
import org.eclipse.xtext.Action;
import org.eclipse.xtext.Parameter;
import org.eclipse.xtext.ParserRule;
import org.eclipse.xtext.serializer.ISerializationContext;
import org.eclipse.xtext.serializer.sequencer.AbstractDelegatingSemanticSequencer;
import pogoDsl.AdditionalFile;
import pogoDsl.Argument;
import pogoDsl.AttrProperties;
import pogoDsl.Attribute;
import pogoDsl.BooleanArrayType;
import pogoDsl.BooleanType;
import pogoDsl.CharArrayType;
import pogoDsl.ClassDescription;
import pogoDsl.ClassIdentification;
import pogoDsl.Command;
import pogoDsl.Comments;
import pogoDsl.ConstStringType;
import pogoDsl.DevIntType;
import pogoDsl.DoubleArrayType;
import pogoDsl.DoubleStringArrayType;
import pogoDsl.DoubleType;
import pogoDsl.DoubleVectorType;
import pogoDsl.EncodedType;
import pogoDsl.EnumType;
import pogoDsl.EventCriteria;
import pogoDsl.FireEvents;
import pogoDsl.FloatArrayType;
import pogoDsl.FloatType;
import pogoDsl.FloatVectorType;
import pogoDsl.ForwardedAttribute;
import pogoDsl.Import;
import pogoDsl.Inheritance;
import pogoDsl.InheritanceStatus;
import pogoDsl.IntArrayType;
import pogoDsl.IntType;
import pogoDsl.IntVectorType;
import pogoDsl.LongArrayType;
import pogoDsl.LongStringArrayType;
import pogoDsl.LongType;
import pogoDsl.OneClassSimpleDef;
import pogoDsl.OverlodedPollPeriodObject;
import pogoDsl.Pipe;
import pogoDsl.PogoDeviceClass;
import pogoDsl.PogoDslPackage;
import pogoDsl.PogoMultiClasses;
import pogoDsl.PogoSystem;
import pogoDsl.Preferences;
import pogoDsl.PropType;
import pogoDsl.Property;
import pogoDsl.ShortArrayType;
import pogoDsl.ShortType;
import pogoDsl.ShortVectorType;
import pogoDsl.SimpleType;
import pogoDsl.State;
import pogoDsl.StateType;
import pogoDsl.StringArrayType;
import pogoDsl.StringType;
import pogoDsl.StringVectorType;
import pogoDsl.Type;
import pogoDsl.UCharType;
import pogoDsl.UIntArrayType;
import pogoDsl.UIntType;
import pogoDsl.ULongArrayType;
import pogoDsl.ULongType;
import pogoDsl.UShortArrayType;
import pogoDsl.UShortType;
import pogoDsl.VectorType;
import pogoDsl.VoidType;

@SuppressWarnings("all")
public class PogoDslSemanticSequencer extends AbstractDelegatingSemanticSequencer {

	@Inject
	private PogoDslGrammarAccess grammarAccess;
	
	@Override
	public void sequence(ISerializationContext context, EObject semanticObject) {
		EPackage epackage = semanticObject.eClass().getEPackage();
		ParserRule rule = context.getParserRule();
		Action action = context.getAssignedAction();
		Set<Parameter> parameters = context.getEnabledBooleanParameters();
		if (epackage == PogoDslPackage.eINSTANCE)
			switch (semanticObject.eClass().getClassifierID()) {
			case PogoDslPackage.ADDITIONAL_FILE:
				sequence_AdditionalFile(context, (AdditionalFile) semanticObject); 
				return; 
			case PogoDslPackage.ARGUMENT:
				sequence_Argument(context, (Argument) semanticObject); 
				return; 
			case PogoDslPackage.ATTR_PROPERTIES:
				sequence_AttrProperties(context, (AttrProperties) semanticObject); 
				return; 
			case PogoDslPackage.ATTRIBUTE:
				sequence_Attribute(context, (Attribute) semanticObject); 
				return; 
			case PogoDslPackage.BOOLEAN_ARRAY_TYPE:
				sequence_BooleanArrayType(context, (BooleanArrayType) semanticObject); 
				return; 
			case PogoDslPackage.BOOLEAN_TYPE:
				sequence_BooleanType(context, (BooleanType) semanticObject); 
				return; 
			case PogoDslPackage.CHAR_ARRAY_TYPE:
				sequence_CharArrayType(context, (CharArrayType) semanticObject); 
				return; 
			case PogoDslPackage.CLASS_DESCRIPTION:
				sequence_ClassDescription(context, (ClassDescription) semanticObject); 
				return; 
			case PogoDslPackage.CLASS_IDENTIFICATION:
				sequence_ClassIdentification(context, (ClassIdentification) semanticObject); 
				return; 
			case PogoDslPackage.COMMAND:
				sequence_Command(context, (Command) semanticObject); 
				return; 
			case PogoDslPackage.COMMENTS:
				sequence_Comments(context, (Comments) semanticObject); 
				return; 
			case PogoDslPackage.CONST_STRING_TYPE:
				sequence_ConstStringType(context, (ConstStringType) semanticObject); 
				return; 
			case PogoDslPackage.DEV_INT_TYPE:
				sequence_DevIntType(context, (DevIntType) semanticObject); 
				return; 
			case PogoDslPackage.DOUBLE_ARRAY_TYPE:
				sequence_DoubleArrayType(context, (DoubleArrayType) semanticObject); 
				return; 
			case PogoDslPackage.DOUBLE_STRING_ARRAY_TYPE:
				sequence_DoubleStringArrayType(context, (DoubleStringArrayType) semanticObject); 
				return; 
			case PogoDslPackage.DOUBLE_TYPE:
				sequence_DoubleType(context, (DoubleType) semanticObject); 
				return; 
			case PogoDslPackage.DOUBLE_VECTOR_TYPE:
				sequence_DoubleVectorType(context, (DoubleVectorType) semanticObject); 
				return; 
			case PogoDslPackage.ENCODED_TYPE:
				sequence_EncodedType(context, (EncodedType) semanticObject); 
				return; 
			case PogoDslPackage.ENUM_TYPE:
				sequence_EnumType(context, (EnumType) semanticObject); 
				return; 
			case PogoDslPackage.EVENT_CRITERIA:
				sequence_EventCriteria(context, (EventCriteria) semanticObject); 
				return; 
			case PogoDslPackage.FIRE_EVENTS:
				sequence_FireEvents(context, (FireEvents) semanticObject); 
				return; 
			case PogoDslPackage.FLOAT_ARRAY_TYPE:
				sequence_FloatArrayType(context, (FloatArrayType) semanticObject); 
				return; 
			case PogoDslPackage.FLOAT_TYPE:
				sequence_FloatType(context, (FloatType) semanticObject); 
				return; 
			case PogoDslPackage.FLOAT_VECTOR_TYPE:
				sequence_FloatVectorType(context, (FloatVectorType) semanticObject); 
				return; 
			case PogoDslPackage.FORWARDED_ATTRIBUTE:
				sequence_ForwardedAttribute(context, (ForwardedAttribute) semanticObject); 
				return; 
			case PogoDslPackage.IMPORT:
				sequence_Import(context, (Import) semanticObject); 
				return; 
			case PogoDslPackage.INHERITANCE:
				sequence_Inheritance(context, (Inheritance) semanticObject); 
				return; 
			case PogoDslPackage.INHERITANCE_STATUS:
				sequence_InheritanceStatus(context, (InheritanceStatus) semanticObject); 
				return; 
			case PogoDslPackage.INT_ARRAY_TYPE:
				sequence_IntArrayType(context, (IntArrayType) semanticObject); 
				return; 
			case PogoDslPackage.INT_TYPE:
				sequence_IntType(context, (IntType) semanticObject); 
				return; 
			case PogoDslPackage.INT_VECTOR_TYPE:
				sequence_IntVectorType(context, (IntVectorType) semanticObject); 
				return; 
			case PogoDslPackage.LONG_ARRAY_TYPE:
				sequence_LongArrayType(context, (LongArrayType) semanticObject); 
				return; 
			case PogoDslPackage.LONG_STRING_ARRAY_TYPE:
				sequence_LongStringArrayType(context, (LongStringArrayType) semanticObject); 
				return; 
			case PogoDslPackage.LONG_TYPE:
				sequence_LongType(context, (LongType) semanticObject); 
				return; 
			case PogoDslPackage.ONE_CLASS_SIMPLE_DEF:
				sequence_OneClassSimpleDef(context, (OneClassSimpleDef) semanticObject); 
				return; 
			case PogoDslPackage.OVERLODED_POLL_PERIOD_OBJECT:
				sequence_OverlodedPollPeriodObject(context, (OverlodedPollPeriodObject) semanticObject); 
				return; 
			case PogoDslPackage.PIPE:
				sequence_Pipe(context, (Pipe) semanticObject); 
				return; 
			case PogoDslPackage.POGO_DEVICE_CLASS:
				sequence_PogoDeviceClass(context, (PogoDeviceClass) semanticObject); 
				return; 
			case PogoDslPackage.POGO_MULTI_CLASSES:
				sequence_PogoMultiClasses(context, (PogoMultiClasses) semanticObject); 
				return; 
			case PogoDslPackage.POGO_SYSTEM:
				sequence_PogoSystem(context, (PogoSystem) semanticObject); 
				return; 
			case PogoDslPackage.PREFERENCES:
				sequence_Preferences(context, (Preferences) semanticObject); 
				return; 
			case PogoDslPackage.PROP_TYPE:
				sequence_PropType_Impl(context, (PropType) semanticObject); 
				return; 
			case PogoDslPackage.PROPERTY:
				sequence_Property(context, (Property) semanticObject); 
				return; 
			case PogoDslPackage.SHORT_ARRAY_TYPE:
				sequence_ShortArrayType(context, (ShortArrayType) semanticObject); 
				return; 
			case PogoDslPackage.SHORT_TYPE:
				sequence_ShortType(context, (ShortType) semanticObject); 
				return; 
			case PogoDslPackage.SHORT_VECTOR_TYPE:
				sequence_ShortVectorType(context, (ShortVectorType) semanticObject); 
				return; 
			case PogoDslPackage.SIMPLE_TYPE:
				sequence_SimpleType_Impl(context, (SimpleType) semanticObject); 
				return; 
			case PogoDslPackage.STATE:
				sequence_State(context, (State) semanticObject); 
				return; 
			case PogoDslPackage.STATE_TYPE:
				sequence_StateType(context, (StateType) semanticObject); 
				return; 
			case PogoDslPackage.STRING_ARRAY_TYPE:
				sequence_StringArrayType(context, (StringArrayType) semanticObject); 
				return; 
			case PogoDslPackage.STRING_TYPE:
				sequence_StringType(context, (StringType) semanticObject); 
				return; 
			case PogoDslPackage.STRING_VECTOR_TYPE:
				sequence_StringVectorType(context, (StringVectorType) semanticObject); 
				return; 
			case PogoDslPackage.TYPE:
				sequence_Type_Impl(context, (Type) semanticObject); 
				return; 
			case PogoDslPackage.UCHAR_TYPE:
				sequence_UCharType(context, (UCharType) semanticObject); 
				return; 
			case PogoDslPackage.UINT_ARRAY_TYPE:
				sequence_UIntArrayType(context, (UIntArrayType) semanticObject); 
				return; 
			case PogoDslPackage.UINT_TYPE:
				sequence_UIntType(context, (UIntType) semanticObject); 
				return; 
			case PogoDslPackage.ULONG_ARRAY_TYPE:
				sequence_ULongArrayType(context, (ULongArrayType) semanticObject); 
				return; 
			case PogoDslPackage.ULONG_TYPE:
				sequence_ULongType(context, (ULongType) semanticObject); 
				return; 
			case PogoDslPackage.USHORT_ARRAY_TYPE:
				sequence_UShortArrayType(context, (UShortArrayType) semanticObject); 
				return; 
			case PogoDslPackage.USHORT_TYPE:
				sequence_UShortType(context, (UShortType) semanticObject); 
				return; 
			case PogoDslPackage.VECTOR_TYPE:
				sequence_VectorType_Impl(context, (VectorType) semanticObject); 
				return; 
			case PogoDslPackage.VOID_TYPE:
				sequence_VoidType(context, (VoidType) semanticObject); 
				return; 
			}
		if (errorAcceptor != null)
			errorAcceptor.accept(diagnosticProvider.createInvalidContextOrTypeDiagnostic(semanticObject, context));
	}
	
	/**
	 * Contexts:
	 *     AdditionalFile returns AdditionalFile
	 *
	 * Constraint:
	 *     (name=EString path=EString?)
	 */
	protected void sequence_AdditionalFile(ISerializationContext context, AdditionalFile semanticObject) {
		genericSequencer.createSequence(context, semanticObject);
	}
	
	
	/**
	 * Contexts:
	 *     Argument returns Argument
	 *
	 * Constraint:
	 *     (description=EString? type=Type?)
	 */
	protected void sequence_Argument(ISerializationContext context, Argument semanticObject) {
		genericSequencer.createSequence(context, semanticObject);
	}
	
	
	/**
	 * Contexts:
	 *     AttrProperties returns AttrProperties
	 *
	 * Constraint:
	 *     (
	 *         description=EString? 
	 *         label=EString? 
	 *         unit=EString? 
	 *         standardUnit=EString? 
	 *         displayUnit=EString? 
	 *         format=EString? 
	 *         maxValue=EString? 
	 *         minValue=EString? 
	 *         maxAlarm=EString? 
	 *         minAlarm=EString? 
	 *         maxWarning=EString? 
	 *         minWarning=EString? 
	 *         deltaTime=EString? 
	 *         deltaValue=EString?
	 *     )
	 */
	protected void sequence_AttrProperties(ISerializationContext context, AttrProperties semanticObject) {
		genericSequencer.createSequence(context, semanticObject);
	}
	
	
	/**
	 * Contexts:
	 *     Attribute returns Attribute
	 *
	 * Constraint:
	 *     (
	 *         name=EString 
	 *         attType=AttrType? 
	 *         rwType=RW_Type? 
	 *         displayLevel=DisplayLevel? 
	 *         polledPeriod=EString? 
	 *         maxX=EString? 
	 *         maxY=EString? 
	 *         associatedAttr=EString? 
	 *         memorized=EString? 
	 *         memorizedAtInit=EString? 
	 *         allocReadMember=EString? 
	 *         isDynamic=EString? 
	 *         (enumLabels+=EString enumLabels+=EString*)? 
	 *         (readExcludedStates+=EString readExcludedStates+=EString*)? 
	 *         (writeExcludedStates+=EString writeExcludedStates+=EString*)? 
	 *         dataType=Type? 
	 *         changeEvent=FireEvents? 
	 *         archiveEvent=FireEvents? 
	 *         dataReadyEvent=FireEvents? 
	 *         status=InheritanceStatus? 
	 *         properties=AttrProperties? 
	 *         eventCriteria=EventCriteria? 
	 *         evArchiveCriteria=EventCriteria?
	 *     )
	 */
	protected void sequence_Attribute(ISerializationContext context, Attribute semanticObject) {
		genericSequencer.createSequence(context, semanticObject);
	}
	
	
	/**
	 * Contexts:
	 *     Type returns BooleanArrayType
	 *     BooleanArrayType returns BooleanArrayType
	 *
	 * Constraint:
	 *     {BooleanArrayType}
	 */
	protected void sequence_BooleanArrayType(ISerializationContext context, BooleanArrayType semanticObject) {
		genericSequencer.createSequence(context, semanticObject);
	}
	
	
	/**
	 * Contexts:
	 *     PropType returns BooleanType
	 *     Type returns BooleanType
	 *     BooleanType returns BooleanType
	 *
	 * Constraint:
	 *     {BooleanType}
	 */
	protected void sequence_BooleanType(ISerializationContext context, BooleanType semanticObject) {
		genericSequencer.createSequence(context, semanticObject);
	}
	
	
	/**
	 * Contexts:
	 *     Type returns CharArrayType
	 *     CharArrayType returns CharArrayType
	 *
	 * Constraint:
	 *     {CharArrayType}
	 */
	protected void sequence_CharArrayType(ISerializationContext context, CharArrayType semanticObject) {
		genericSequencer.createSequence(context, semanticObject);
	}
	
	
	/**
	 * Contexts:
	 *     ClassDescription returns ClassDescription
	 *
	 * Constraint:
	 *     (
	 *         description=EString? 
	 *         title=EString? 
	 *         sourcePath=EString? 
	 *         language=Language? 
	 *         filestogenerate=EString? 
	 *         license=EString? 
	 *         hasMandatoryProperty=Boolean? 
	 *         hasConcreteProperty=Boolean? 
	 *         hasAbstractCommand=Boolean? 
	 *         hasAbstractAttribute=Boolean? 
	 *         descriptionHtmlExists=Boolean? 
	 *         (inheritances+=Inheritance inheritances+=Inheritance*)? 
	 *         identification=ClassIdentification? 
	 *         comments=Comments?
	 *     )
	 */
	protected void sequence_ClassDescription(ISerializationContext context, ClassDescription semanticObject) {
		genericSequencer.createSequence(context, semanticObject);
	}
	
	
	/**
	 * Contexts:
	 *     ClassIdentification returns ClassIdentification
	 *
	 * Constraint:
	 *     (
	 *         contact=EString? 
	 *         author=EString? 
	 *         emailDomain=EString? 
	 *         classFamily=EString? 
	 *         siteSpecific=EString? 
	 *         platform=EString? 
	 *         bus=EString? 
	 *         manufacturer=EString? 
	 *         reference=EString? 
	 *         (keyWords+=EString keyWords+=EString*)?
	 *     )
	 */
	protected void sequence_ClassIdentification(ISerializationContext context, ClassIdentification semanticObject) {
		genericSequencer.createSequence(context, semanticObject);
	}
	
	
	/**
	 * Contexts:
	 *     Command returns Command
	 *
	 * Constraint:
	 *     (
	 *         name=EString 
	 *         description=EString? 
	 *         execMethod=EString? 
	 *         displayLevel=DisplayLevel? 
	 *         polledPeriod=EString? 
	 *         isDynamic=EString? 
	 *         (excludedStates+=EString excludedStates+=EString*)? 
	 *         argin=Argument? 
	 *         argout=Argument? 
	 *         status=InheritanceStatus?
	 *     )
	 */
	protected void sequence_Command(ISerializationContext context, Command semanticObject) {
		genericSequencer.createSequence(context, semanticObject);
	}
	
	
	/**
	 * Contexts:
	 *     Comments returns Comments
	 *
	 * Constraint:
	 *     commandsTable=EString?
	 */
	protected void sequence_Comments(ISerializationContext context, Comments semanticObject) {
		genericSequencer.createSequence(context, semanticObject);
	}
	
	
	/**
	 * Contexts:
	 *     Type returns ConstStringType
	 *     ConstStringType returns ConstStringType
	 *
	 * Constraint:
	 *     {ConstStringType}
	 */
	protected void sequence_ConstStringType(ISerializationContext context, ConstStringType semanticObject) {
		genericSequencer.createSequence(context, semanticObject);
	}
	
	
	/**
	 * Contexts:
	 *     Type returns DevIntType
	 *     DevIntType returns DevIntType
	 *
	 * Constraint:
	 *     {DevIntType}
	 */
	protected void sequence_DevIntType(ISerializationContext context, DevIntType semanticObject) {
		genericSequencer.createSequence(context, semanticObject);
	}
	
	
	/**
	 * Contexts:
	 *     Type returns DoubleArrayType
	 *     DoubleArrayType returns DoubleArrayType
	 *
	 * Constraint:
	 *     {DoubleArrayType}
	 */
	protected void sequence_DoubleArrayType(ISerializationContext context, DoubleArrayType semanticObject) {
		genericSequencer.createSequence(context, semanticObject);
	}
	
	
	/**
	 * Contexts:
	 *     Type returns DoubleStringArrayType
	 *     DoubleStringArrayType returns DoubleStringArrayType
	 *
	 * Constraint:
	 *     {DoubleStringArrayType}
	 */
	protected void sequence_DoubleStringArrayType(ISerializationContext context, DoubleStringArrayType semanticObject) {
		genericSequencer.createSequence(context, semanticObject);
	}
	
	
	/**
	 * Contexts:
	 *     PropType returns DoubleType
	 *     Type returns DoubleType
	 *     DoubleType returns DoubleType
	 *
	 * Constraint:
	 *     {DoubleType}
	 */
	protected void sequence_DoubleType(ISerializationContext context, DoubleType semanticObject) {
		genericSequencer.createSequence(context, semanticObject);
	}
	
	
	/**
	 * Contexts:
	 *     PropType returns DoubleVectorType
	 *     DoubleVectorType returns DoubleVectorType
	 *
	 * Constraint:
	 *     {DoubleVectorType}
	 */
	protected void sequence_DoubleVectorType(ISerializationContext context, DoubleVectorType semanticObject) {
		genericSequencer.createSequence(context, semanticObject);
	}
	
	
	/**
	 * Contexts:
	 *     Type returns EncodedType
	 *     EncodedType returns EncodedType
	 *
	 * Constraint:
	 *     {EncodedType}
	 */
	protected void sequence_EncodedType(ISerializationContext context, EncodedType semanticObject) {
		genericSequencer.createSequence(context, semanticObject);
	}
	
	
	/**
	 * Contexts:
	 *     Type returns EnumType
	 *     EnumType returns EnumType
	 *
	 * Constraint:
	 *     {EnumType}
	 */
	protected void sequence_EnumType(ISerializationContext context, EnumType semanticObject) {
		genericSequencer.createSequence(context, semanticObject);
	}
	
	
	/**
	 * Contexts:
	 *     EventCriteria returns EventCriteria
	 *
	 * Constraint:
	 *     (relChange=EString? absChange=EString? period=EString?)
	 */
	protected void sequence_EventCriteria(ISerializationContext context, EventCriteria semanticObject) {
		genericSequencer.createSequence(context, semanticObject);
	}
	
	
	/**
	 * Contexts:
	 *     FireEvents returns FireEvents
	 *
	 * Constraint:
	 *     (fire=EString? libCheckCriteria=EString?)
	 */
	protected void sequence_FireEvents(ISerializationContext context, FireEvents semanticObject) {
		genericSequencer.createSequence(context, semanticObject);
	}
	
	
	/**
	 * Contexts:
	 *     Type returns FloatArrayType
	 *     FloatArrayType returns FloatArrayType
	 *
	 * Constraint:
	 *     {FloatArrayType}
	 */
	protected void sequence_FloatArrayType(ISerializationContext context, FloatArrayType semanticObject) {
		genericSequencer.createSequence(context, semanticObject);
	}
	
	
	/**
	 * Contexts:
	 *     PropType returns FloatType
	 *     Type returns FloatType
	 *     FloatType returns FloatType
	 *
	 * Constraint:
	 *     {FloatType}
	 */
	protected void sequence_FloatType(ISerializationContext context, FloatType semanticObject) {
		genericSequencer.createSequence(context, semanticObject);
	}
	
	
	/**
	 * Contexts:
	 *     PropType returns FloatVectorType
	 *     FloatVectorType returns FloatVectorType
	 *
	 * Constraint:
	 *     {FloatVectorType}
	 */
	protected void sequence_FloatVectorType(ISerializationContext context, FloatVectorType semanticObject) {
		genericSequencer.createSequence(context, semanticObject);
	}
	
	
	/**
	 * Contexts:
	 *     ForwardedAttribute returns ForwardedAttribute
	 *
	 * Constraint:
	 *     (name=EString label=EString? status=InheritanceStatus?)
	 */
	protected void sequence_ForwardedAttribute(ISerializationContext context, ForwardedAttribute semanticObject) {
		genericSequencer.createSequence(context, semanticObject);
	}
	
	
	/**
	 * Contexts:
	 *     Import returns Import
	 *
	 * Constraint:
	 *     importURI=EString?
	 */
	protected void sequence_Import(ISerializationContext context, Import semanticObject) {
		genericSequencer.createSequence(context, semanticObject);
	}
	
	
	/**
	 * Contexts:
	 *     InheritanceStatus returns InheritanceStatus
	 *
	 * Constraint:
	 *     (abstract=EString? inherited=EString? concrete=EString? concreteHere=EString? hasChanged=EString?)
	 */
	protected void sequence_InheritanceStatus(ISerializationContext context, InheritanceStatus semanticObject) {
		genericSequencer.createSequence(context, semanticObject);
	}
	
	
	/**
	 * Contexts:
	 *     Inheritance returns Inheritance
	 *
	 * Constraint:
	 *     (classname=EString? sourcePath=EString?)
	 */
	protected void sequence_Inheritance(ISerializationContext context, Inheritance semanticObject) {
		genericSequencer.createSequence(context, semanticObject);
	}
	
	
	/**
	 * Contexts:
	 *     Type returns IntArrayType
	 *     IntArrayType returns IntArrayType
	 *
	 * Constraint:
	 *     {IntArrayType}
	 */
	protected void sequence_IntArrayType(ISerializationContext context, IntArrayType semanticObject) {
		genericSequencer.createSequence(context, semanticObject);
	}
	
	
	/**
	 * Contexts:
	 *     PropType returns IntType
	 *     Type returns IntType
	 *     IntType returns IntType
	 *
	 * Constraint:
	 *     {IntType}
	 */
	protected void sequence_IntType(ISerializationContext context, IntType semanticObject) {
		genericSequencer.createSequence(context, semanticObject);
	}
	
	
	/**
	 * Contexts:
	 *     PropType returns IntVectorType
	 *     IntVectorType returns IntVectorType
	 *
	 * Constraint:
	 *     {IntVectorType}
	 */
	protected void sequence_IntVectorType(ISerializationContext context, IntVectorType semanticObject) {
		genericSequencer.createSequence(context, semanticObject);
	}
	
	
	/**
	 * Contexts:
	 *     Type returns LongArrayType
	 *     LongArrayType returns LongArrayType
	 *
	 * Constraint:
	 *     {LongArrayType}
	 */
	protected void sequence_LongArrayType(ISerializationContext context, LongArrayType semanticObject) {
		genericSequencer.createSequence(context, semanticObject);
	}
	
	
	/**
	 * Contexts:
	 *     Type returns LongStringArrayType
	 *     LongStringArrayType returns LongStringArrayType
	 *
	 * Constraint:
	 *     {LongStringArrayType}
	 */
	protected void sequence_LongStringArrayType(ISerializationContext context, LongStringArrayType semanticObject) {
		genericSequencer.createSequence(context, semanticObject);
	}
	
	
	/**
	 * Contexts:
	 *     Type returns LongType
	 *     LongType returns LongType
	 *
	 * Constraint:
	 *     {LongType}
	 */
	protected void sequence_LongType(ISerializationContext context, LongType semanticObject) {
		genericSequencer.createSequence(context, semanticObject);
	}
	
	
	/**
	 * Contexts:
	 *     OneClassSimpleDef returns OneClassSimpleDef
	 *
	 * Constraint:
	 *     (
	 *         classname=EString? 
	 *         sourcePath=EString? 
	 *         hasDynamic=EString? 
	 *         pogo6=EString? 
	 *         (parentClasses+=EString parentClasses+=EString*)? 
	 *         (inheritances+=Inheritance inheritances+=Inheritance*)? 
	 *         (additionalFiles+=AdditionalFile additionalFiles+=AdditionalFile*)?
	 *     )
	 */
	protected void sequence_OneClassSimpleDef(ISerializationContext context, OneClassSimpleDef semanticObject) {
		genericSequencer.createSequence(context, semanticObject);
	}
	
	
	/**
	 * Contexts:
	 *     OverlodedPollPeriodObject returns OverlodedPollPeriodObject
	 *
	 * Constraint:
	 *     (name=EString type=EString? pollPeriod=EString?)
	 */
	protected void sequence_OverlodedPollPeriodObject(ISerializationContext context, OverlodedPollPeriodObject semanticObject) {
		genericSequencer.createSequence(context, semanticObject);
	}
	
	
	/**
	 * Contexts:
	 *     Pipe returns Pipe
	 *
	 * Constraint:
	 *     (
	 *         name=EString 
	 *         description=EString? 
	 *         label=EString? 
	 *         rwType=EString? 
	 *         displayLevel=DisplayLevel? 
	 *         (readExcludedStates+=EString readExcludedStates+=EString*)? 
	 *         (writeExcludedStates+=EString writeExcludedStates+=EString*)?
	 *     )
	 */
	protected void sequence_Pipe(ISerializationContext context, Pipe semanticObject) {
		genericSequencer.createSequence(context, semanticObject);
	}
	
	
	/**
	 * Contexts:
	 *     PogoDeviceClass returns PogoDeviceClass
	 *
	 * Constraint:
	 *     (
	 *         isAbstract?='isAbstract'? 
	 *         name=EString 
	 *         refferedControlNode=[ControlNode|QualifiedName]? 
	 *         pogoRevision=EString? 
	 *         institute=EString? 
	 *         baseClass=[PogoDeviceClass|EString]? 
	 *         description=ClassDescription? 
	 *         (classProperties+=Property classProperties+=Property*)? 
	 *         (deviceProperties+=Property deviceProperties+=Property*)? 
	 *         (commands+=Command commands+=Command*)? 
	 *         (dynamicCommands+=Command dynamicCommands+=Command*)? 
	 *         (attributes+=Attribute attributes+=Attribute*)? 
	 *         (dynamicAttributes+=Attribute dynamicAttributes+=Attribute*)? 
	 *         (forwardedAttributes+=ForwardedAttribute forwardedAttributes+=ForwardedAttribute*)? 
	 *         (pipes+=Pipe pipes+=Pipe*)? 
	 *         (states+=State states+=State*)? 
	 *         preferences=Preferences? 
	 *         (additionalFiles+=AdditionalFile additionalFiles+=AdditionalFile*)? 
	 *         (overlodedPollPeriodObject+=OverlodedPollPeriodObject overlodedPollPeriodObject+=OverlodedPollPeriodObject*)?
	 *     )
	 */
	protected void sequence_PogoDeviceClass(ISerializationContext context, PogoDeviceClass semanticObject) {
		genericSequencer.createSequence(context, semanticObject);
	}
	
	
	/**
	 * Contexts:
	 *     PogoMultiClasses returns PogoMultiClasses
	 *
	 * Constraint:
	 *     (
	 *         name=EString 
	 *         pogoRevision=EString? 
	 *         sourcePath=EString? 
	 *         description=EString? 
	 *         title=EString? 
	 *         license=EString? 
	 *         filestogenerate=EString? 
	 *         (classes+=OneClassSimpleDef classes+=OneClassSimpleDef*)? 
	 *         preferences=Preferences?
	 *     )
	 */
	protected void sequence_PogoMultiClasses(ISerializationContext context, PogoMultiClasses semanticObject) {
		genericSequencer.createSequence(context, semanticObject);
	}
	
	
	/**
	 * Contexts:
	 *     PogoSystem returns PogoSystem
	 *
	 * Constraint:
	 *     (
	 *         (imports+=Import imports+=Import*)? 
	 *         (classes+=PogoDeviceClass classes+=PogoDeviceClass*)? 
	 *         (multiClasses+=PogoMultiClasses multiClasses+=PogoMultiClasses*)?
	 *     )
	 */
	protected void sequence_PogoSystem(ISerializationContext context, PogoSystem semanticObject) {
		genericSequencer.createSequence(context, semanticObject);
	}
	
	
	/**
	 * Contexts:
	 *     Preferences returns Preferences
	 *
	 * Constraint:
	 *     (docHome=EString? makefileHome=EString? installHome=EString? htmlVersion=EString?)
	 */
	protected void sequence_Preferences(ISerializationContext context, Preferences semanticObject) {
		genericSequencer.createSequence(context, semanticObject);
	}
	
	
	/**
	 * Contexts:
	 *     PropType returns PropType
	 *     PropType_Impl returns PropType
	 *
	 * Constraint:
	 *     {PropType}
	 */
	protected void sequence_PropType_Impl(ISerializationContext context, PropType semanticObject) {
		genericSequencer.createSequence(context, semanticObject);
	}
	
	
	/**
	 * Contexts:
	 *     Property returns Property
	 *
	 * Constraint:
	 *     (
	 *         name=EString 
	 *         mandatory=EString? 
	 *         description=EString? 
	 *         (DefaultPropValue+=EString DefaultPropValue+=EString*)? 
	 *         type=PropType? 
	 *         status=InheritanceStatus?
	 *     )
	 */
	protected void sequence_Property(ISerializationContext context, Property semanticObject) {
		genericSequencer.createSequence(context, semanticObject);
	}
	
	
	/**
	 * Contexts:
	 *     Type returns ShortArrayType
	 *     ShortArrayType returns ShortArrayType
	 *
	 * Constraint:
	 *     {ShortArrayType}
	 */
	protected void sequence_ShortArrayType(ISerializationContext context, ShortArrayType semanticObject) {
		genericSequencer.createSequence(context, semanticObject);
	}
	
	
	/**
	 * Contexts:
	 *     PropType returns ShortType
	 *     Type returns ShortType
	 *     ShortType returns ShortType
	 *
	 * Constraint:
	 *     {ShortType}
	 */
	protected void sequence_ShortType(ISerializationContext context, ShortType semanticObject) {
		genericSequencer.createSequence(context, semanticObject);
	}
	
	
	/**
	 * Contexts:
	 *     PropType returns ShortVectorType
	 *     ShortVectorType returns ShortVectorType
	 *
	 * Constraint:
	 *     {ShortVectorType}
	 */
	protected void sequence_ShortVectorType(ISerializationContext context, ShortVectorType semanticObject) {
		genericSequencer.createSequence(context, semanticObject);
	}
	
	
	/**
	 * Contexts:
	 *     PropType returns SimpleType
	 *     SimpleType_Impl returns SimpleType
	 *
	 * Constraint:
	 *     {SimpleType}
	 */
	protected void sequence_SimpleType_Impl(ISerializationContext context, SimpleType semanticObject) {
		genericSequencer.createSequence(context, semanticObject);
	}
	
	
	/**
	 * Contexts:
	 *     Type returns StateType
	 *     StateType returns StateType
	 *
	 * Constraint:
	 *     {StateType}
	 */
	protected void sequence_StateType(ISerializationContext context, StateType semanticObject) {
		genericSequencer.createSequence(context, semanticObject);
	}
	
	
	/**
	 * Contexts:
	 *     State returns State
	 *
	 * Constraint:
	 *     (name=EString description=EString? status=InheritanceStatus?)
	 */
	protected void sequence_State(ISerializationContext context, State semanticObject) {
		genericSequencer.createSequence(context, semanticObject);
	}
	
	
	/**
	 * Contexts:
	 *     Type returns StringArrayType
	 *     StringArrayType returns StringArrayType
	 *
	 * Constraint:
	 *     {StringArrayType}
	 */
	protected void sequence_StringArrayType(ISerializationContext context, StringArrayType semanticObject) {
		genericSequencer.createSequence(context, semanticObject);
	}
	
	
	/**
	 * Contexts:
	 *     PropType returns StringType
	 *     Type returns StringType
	 *     StringType returns StringType
	 *
	 * Constraint:
	 *     {StringType}
	 */
	protected void sequence_StringType(ISerializationContext context, StringType semanticObject) {
		genericSequencer.createSequence(context, semanticObject);
	}
	
	
	/**
	 * Contexts:
	 *     PropType returns StringVectorType
	 *     StringVectorType returns StringVectorType
	 *
	 * Constraint:
	 *     {StringVectorType}
	 */
	protected void sequence_StringVectorType(ISerializationContext context, StringVectorType semanticObject) {
		genericSequencer.createSequence(context, semanticObject);
	}
	
	
	/**
	 * Contexts:
	 *     Type returns Type
	 *     Type_Impl returns Type
	 *
	 * Constraint:
	 *     {Type}
	 */
	protected void sequence_Type_Impl(ISerializationContext context, Type semanticObject) {
		genericSequencer.createSequence(context, semanticObject);
	}
	
	
	/**
	 * Contexts:
	 *     Type returns UCharType
	 *     UCharType returns UCharType
	 *
	 * Constraint:
	 *     {UCharType}
	 */
	protected void sequence_UCharType(ISerializationContext context, UCharType semanticObject) {
		genericSequencer.createSequence(context, semanticObject);
	}
	
	
	/**
	 * Contexts:
	 *     Type returns UIntArrayType
	 *     UIntArrayType returns UIntArrayType
	 *
	 * Constraint:
	 *     {UIntArrayType}
	 */
	protected void sequence_UIntArrayType(ISerializationContext context, UIntArrayType semanticObject) {
		genericSequencer.createSequence(context, semanticObject);
	}
	
	
	/**
	 * Contexts:
	 *     PropType returns UIntType
	 *     Type returns UIntType
	 *     UIntType returns UIntType
	 *
	 * Constraint:
	 *     {UIntType}
	 */
	protected void sequence_UIntType(ISerializationContext context, UIntType semanticObject) {
		genericSequencer.createSequence(context, semanticObject);
	}
	
	
	/**
	 * Contexts:
	 *     Type returns ULongArrayType
	 *     ULongArrayType returns ULongArrayType
	 *
	 * Constraint:
	 *     {ULongArrayType}
	 */
	protected void sequence_ULongArrayType(ISerializationContext context, ULongArrayType semanticObject) {
		genericSequencer.createSequence(context, semanticObject);
	}
	
	
	/**
	 * Contexts:
	 *     Type returns ULongType
	 *     ULongType returns ULongType
	 *
	 * Constraint:
	 *     {ULongType}
	 */
	protected void sequence_ULongType(ISerializationContext context, ULongType semanticObject) {
		genericSequencer.createSequence(context, semanticObject);
	}
	
	
	/**
	 * Contexts:
	 *     Type returns UShortArrayType
	 *     UShortArrayType returns UShortArrayType
	 *
	 * Constraint:
	 *     {UShortArrayType}
	 */
	protected void sequence_UShortArrayType(ISerializationContext context, UShortArrayType semanticObject) {
		genericSequencer.createSequence(context, semanticObject);
	}
	
	
	/**
	 * Contexts:
	 *     PropType returns UShortType
	 *     Type returns UShortType
	 *     UShortType returns UShortType
	 *
	 * Constraint:
	 *     {UShortType}
	 */
	protected void sequence_UShortType(ISerializationContext context, UShortType semanticObject) {
		genericSequencer.createSequence(context, semanticObject);
	}
	
	
	/**
	 * Contexts:
	 *     PropType returns VectorType
	 *     VectorType_Impl returns VectorType
	 *
	 * Constraint:
	 *     {VectorType}
	 */
	protected void sequence_VectorType_Impl(ISerializationContext context, VectorType semanticObject) {
		genericSequencer.createSequence(context, semanticObject);
	}
	
	
	/**
	 * Contexts:
	 *     Type returns VoidType
	 *     VoidType returns VoidType
	 *
	 * Constraint:
	 *     {VoidType}
	 */
	protected void sequence_VoidType(ISerializationContext context, VoidType semanticObject) {
		genericSequencer.createSequence(context, semanticObject);
	}
	
	
}
